VST 3 SDK VST 3.7 SDK for developing VST plug-in

Public Member Functions | List of all members
VSTGUIEditor Class Referenceabstract
VST Implementation Helper Classes

Base class for an edit view using VSTGUI. More...

`#include <vstguieditor.h>`

Inheritance diagram for VSTGUIEditor:

## Public Member Functions
| VSTGUIEditor (void *controller, ViewRect *size=nullptr)
| Constructor. More...
virtual | ~VSTGUIEditor ()
| Destructor. More...
virtual bool | open (void *parent)=0
| Called when the editor will be opened. More...
virtual void | close ()=0
| Called when the editor will be closed. More...
void | setIdleRate (int32 millisec)
| Sets the idle rate controlling the parameter update rate. More...
VSTGUI::CMessageResult | notify (VSTGUI::CBaseObject *sender, const char *message) SMTG_OVERRIDE
void | forget () SMTG_OVERRIDE
void | remember () SMTG_OVERRIDE
long | getNbReference () const SMTG_OVERRIDE
tresult | isPlatformTypeSupported (FIDString type) SMTG_OVERRIDE
tresult | onSize (ViewRect *newSize) SMTG_OVERRIDE
void | beginEdit (long index) SMTG_OVERRIDE
| Called from VSTGUI when a user begins editing. More...
void | endEdit (long index) SMTG_OVERRIDE
| Called from VSTGUI when a user ends editing. More...
long | getKnobMode () const SMTG_OVERRIDE
OBJ_METHODS(VSTGUIEditor, EditorView) DEFINE_INTERFACES END_DEFINE_INTERFACES(EditorView) REFCOUNT_METHODS(EditorView) protected tresult | removed () SMTG_OVERRIDE
tresult | onKeyDown (char16 key, int16 keyMsg, int16 modifiers) SMTG_OVERRIDE
tresult | onKeyUp (char16 key, int16 keyMsg, int16 modifiers) SMTG_OVERRIDE
tresult | onWheel (float distance) SMTG_OVERRIDE
tresult | setFrame (IPlugFrame *frame) SMTG_OVERRIDE
Public Member Functions inherited from EditorView
| EditorView (EditController *controller, ViewRect *size=nullptr)
| ~EditorView () override
EditController * | getController () const
| Gets its controller part. More...
void | attachedToParent () SMTG_OVERRIDE
void | removedFromParent () SMTG_OVERRIDE
Public Member Functions inherited from CPluginView
| CPluginView (const ViewRect *rect=nullptr)
| ~CPluginView () SMTG_OVERRIDE
const ViewRect & | getRect () const
| Returns its current frame rectangle. More...
void | setRect (const ViewRect &r)
| Sets a new frame rectangle. More...
bool | isAttached () const
| Checks if this view is attached to its parent view. More...
virtual void | attachedToParent ()
| Calls when this view will be attached to its parent view. More...
virtual void | removedFromParent ()
| Calls when this view will be removed from its parent view. More...
tresult | isPlatformTypeSupported (FIDString type) SMTG_OVERRIDE
tresult | attached (void *parent, FIDString type) SMTG_OVERRIDE
tresult | removed () SMTG_OVERRIDE
tresult | onWheel (float) SMTG_OVERRIDE
tresult | onKeyDown (char16, int16, int16) SMTG_OVERRIDE
tresult | onKeyUp (char16, int16, int16) SMTG_OVERRIDE
tresult | getSize (ViewRect *size) SMTG_OVERRIDE
tresult | onSize (ViewRect *newSize) SMTG_OVERRIDE
tresult | onFocus (TBool) SMTG_OVERRIDE
tresult | setFrame (IPlugFrame *frame) SMTG_OVERRIDE
tresult | canResize () SMTG_OVERRIDE
tresult | checkSizeConstraint (ViewRect *) SMTG_OVERRIDE
virtual tresult | isPlatformTypeSupported (FIDString type)=0
virtual tresult | attached (void *parent, FIDString type)=0
virtual tresult | removed ()=0
virtual tresult | onWheel (float distance)=0
virtual tresult | onKeyDown (char16 key, int16 keyCode, int16 modifiers)=0
virtual tresult | onKeyUp (char16 key, int16 keyCode, int16 modifiers)=0
virtual tresult | getSize (ViewRect *size)=0
virtual tresult | onSize (ViewRect *newSize)=0
virtual tresult | onFocus (TBool state)=0
virtual tresult | setFrame (IPlugFrame *frame)=0
virtual tresult | canResize ()=0
virtual tresult | checkSizeConstraint (ViewRect *rect)=0
Public Member Functions inherited from FUnknown
virtual tresult | queryInterface (const TUID _iid, void **obj)=0
virtual uint32 | addRef ()=0
virtual uint32 | release ()=0

## Additional Inherited Members
Public Attributes inherited from CPluginView
OBJ_METHODS(CPluginView, FObject) DEFINE_INTERFACES DEF_INTERFACE(IPlugView) END_DEFINE_INTERFACES(FObject) REFCOUNT_METHODS(FObject) protected void * | systemWindow {nullptr}
IPtr< IPlugFrame > | plugFrame
Static Public Attributes inherited from IPlugView
static const FUID | iid
Static Public Attributes inherited from FUnknown
static const FUID | iid
Protected Attributes inherited from EditorView
IPtr< EditController > | controller

## Detailed Description

Base class for an edit view using VSTGUI.

## Constructor & Destructor Documentation

## ◆ VSTGUIEditor()

VSTGUIEditor | ( | void * | controller,
|  | ViewRect * | size = `nullptr`
| ) |  |

Constructor.

## ◆ ~VSTGUIEditor()

~VSTGUIEditor | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ open()

virtual bool open | ( | void * | parent | ) |
| pure virtual

Called when the editor will be opened.

## ◆ close()

virtual void close | ( |  | ) |
| pure virtual

Called when the editor will be closed.

## ◆ setIdleRate()

void setIdleRate | ( | int32 | millisec | ) |

Sets the idle rate controlling the parameter update rate.

## ◆ notify()

CMessageResult notify | ( | VSTGUI::CBaseObject * | sender,
|  | const char * | message
| ) |  |

## ◆ forget()

void forget | ( |  | ) |
| inline

## ◆ remember()

void remember | ( |  | ) |
| inline

## ◆ getNbReference()

long getNbReference | ( |  | ) | const
| inline

## ◆ isPlatformTypeSupported()

tresult isPlatformTypeSupported | ( | FIDString | type | ) |
| virtual

Implements IPlugView.

## ◆ onSize()

tresult onSize | ( | ViewRect * | newSize | ) |
| virtual

Implements IPlugView.

## ◆ beginEdit()

void beginEdit | ( | long | index | ) |

Called from VSTGUI when a user begins editing.

The default implementation calls performEdit of the EditController.

## ◆ endEdit()

void endEdit | ( | long | index | ) |

Called from VSTGUI when a user ends editing.

The default implementation calls endEdit of the EditController.

## ◆ getKnobMode()

long getKnobMode | ( |  | ) | const

## ◆ removed()

tresult removed | ( |  | ) |
| virtual

Implements IPlugView.

## ◆ onKeyDown()

tresult onKeyDown | ( | char16 | key,
|  | int16 | keyMsg,
|  | int16 | modifiers
| ) |  |
| virtual

Implements IPlugView.

## ◆ onKeyUp()

tresult onKeyUp | ( | char16 | key,
|  | int16 | keyMsg,
|  | int16 | modifiers
| ) |  |
| virtual

Implements IPlugView.

## ◆ onWheel()

tresult onWheel | ( | float | distance | ) |
| virtual

Implements IPlugView.

## ◆ setFrame()

tresult setFrame | ( | IPlugFrame * | frame | ) |
| virtual

Implements IPlugView.

Empty

Copyright © Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.